import HsShellScript
import System.Posix
import qualified Control.Exception


main = mainwrapper $ do 
   logm "1. With run:\n"
   doit run "ls" ["/"]
   doit run "ls" ["/frooble"]

   logm "\n\n\n2. With runprog:\n"
   doit runprog "ls" ["/"]
   doit runprog "ls" ["/frooble"]
   doit runprog "/frooble" []

   logm "\n\n\n3. With runprog, terminating with a signal:\n"
   spawn (do sleep 1
             runprog "killall" ["sleep"]
         )
   doit runprog "sleep" ["3"]

   logm_ "\n\nexitcode $ runprog \"/bin/false\" [] = "
   ec <- exitcode $ runprog "/bin/false" []
   outm (show ec)


doit fkt prog par = 
   do logm ("Calling " ++ shell_command prog par ++ ": ")
      fkt prog par
      logm ""
   `catch`                      (\ioe -> outm (show_ioerror ioe))
   `catchDyn`                   (\(ps::ProcessStatus) -> outm ("Caught ProcessStatus:\n" ++ show ps))
   `catchDyn`                   (\(re::RunError) -> outm ("Caught RunError:\n" ++ show_runerror re))
   `Control.Exception.catch`    (\e -> outm ("Caught unexpected exception:\n" ++ show e))

